#include <dos.h>
#include <stdio.h>
#include <bios.h>
#include <stdlib.h>

#define INTR 0x1C

#ifdef __cplusplus
    #define __CPPARGS ...
#else
    #define __CPPARGS
#endif

union REGS inregs, outregs;
struct SREGS segs;

#define ALT_A	       7680
#define ALT_B	      12288

volatile   char  mapa_teclado[256];

extern unsigned _heaplen = 1024;
extern unsigned _stklen  = 512;
int tec_puls;
int tecl=ALT_A;
char dentro=0;
int up=0;
int down=0;
int left=0;
int right=0;

void interrupt ( *oldhandler)(__CPPARGS);
extern "C" void  SCROLL(int);

typedef unsigned int (far *s_arrayptr);

void interrupt handler(__CPPARGS)
{
	if(bioskey(1)) tec_puls=bioskey(0);
	if (tec_puls==tecl)
	{
		for (int z1=0; z1<up; z1++) SCROLL(1);
		for (int z2=0; z2<down; z2++) SCROLL(2);
		for (int z3=0; z3<left; z3++) SCROLL(3);
		for (int z4=0; z4<right; z4++) SCROLL(4);
	  if (tecl==ALT_A) tecl=ALT_B; else tecl=ALT_A;
	}
	oldhandler();
}

int main(int argc, char* argv[])
{
	if (argc!=5) {printf("\nFormato: TSRSCROL up down left right\n\n  (siendo <up> <down> ...  un valor en pixels\nEjemplo: TSRSCROL 100 0 0 0\n"); return 0;}
	printf("Rutina SCROLL de Andrs del Campo.\n\nPulse ALT-A para activar.\nPulse ALT-B para activar por segunda vez.\nALT-A por tercera... \n\nOjo! Slo para 320 por 200\n");
	up=atoi(argv[1]);
	down=atoi(argv[2]);
	left=atoi(argv[3])/2;
	right=atoi(argv[4])/2;
	oldhandler = _dos_getvect(INTR);
	_dos_setvect(INTR, handler);
	_dos_keep(0, (_SS + (_SP/16) - _psp));
	return 0;
}
